//*****************************************************************
//  
//  Copyright, IDAutomation.com, Inc. 2000-2004. All rights reserved.
//  
//  http://www.IDAutomation.com/
//  
//  NOTICE:
//  You may incorporate our Source Code in your application
//  only if you own a valid Java Barcode Package License
//  from IDAutomation.com, Inc. and the copyright notices 
//  are not removed from the source code.
//  
//
//*****************************************************************

import java.io.*;
import com.idautomation.datamatrix.*;
import com.idautomation.datamatrix.encoder.*;

class DMByteExample

{
    public static void main ( String [] args )
    {

		//Generate the byte array
		byte[] myByteArray = new byte[256];
		for (int i = 0; i < 256; i++) 
		{
			myByteArray[i] = (byte) i;
		}

		//Create the DataMatrix object and set parameters
		DataMatrix bc = new DataMatrix();
		bc.encoding = DataMatrix.E_BASE256;
		bc.processTilde=false;
		bc.code="";

		//Convert the byte array and pass to "code"
		String binaryString;
		for (int i=0; i < myByteArray.length; i++) 
		{
			binaryString = Integer.toBinaryString((int)myByteArray[i]);
			if (binaryString.length() > 8)
				binaryString = binaryString.substring(binaryString.length()-8,binaryString.length());
			bc.code = bc.code + (char) Integer.parseInt(binaryString,2);
		}


		// create the file as the name of the message
		barCodeEncoder bce = new barCodeEncoder(bc, "GIF", "DMByteExample.gif");
		System.exit(0);
    }


}
