//*****************************************************************
// 
//  JAVA Source for com.idautomation.maxicode; 4.10
//  
//  Copyright, IDAutomation.com, Inc. 2000-2004. 
//  All rights reserved.
//  
//  http://www.IDAutomation.com/java/
//  
//  NOTICE:
//  You may incorporate our Source Code in your application
//  only if you own a valid Java Developer License
//  from IDAutomation.com, Inc. and the copyright notices 
//  are not removed from the source code.
//  
//*****************************************************************

package com.idautomation.maxicode.encoder;
import java.awt.*;

public class barCodeEncoder {

   String sFile;
   String sFormat;
   com.idautomation.maxicode.MaxiCode  bc;
   public boolean result;

  public barCodeEncoder(com.idautomation.maxicode.MaxiCode c,String psFormat,String psFile) {

     sFormat=psFormat;
     sFile=psFile;
     bc=c;

     result=encode();
  }


  private boolean encode() {
    if (sFormat.toUpperCase().compareTo("GIF")==0) return saveToGIF();
    if (sFormat.toUpperCase().compareTo("JPEG")==0) return saveToJPEG();
    return false;
  }

   private boolean saveToGIF() {
          String v=java.lang.System.getProperty("java.version");
          if (v.indexOf("1.1")==0) return false;

           try {

            //create bufferred image
            int bcw=bc.getPreferredSize().width;
            int bch=bc.getPreferredSize().height;

            java.awt.image.BufferedImage image = new java.awt.image.BufferedImage( bcw,bch,java.awt.image.BufferedImage.TYPE_BYTE_INDEXED );
            //java.awt.Image image=c.createImage(c.getSize().width,c.getSize().height);
            java.awt.Graphics imgGraphics = image.createGraphics();

             bc.paint(imgGraphics );

            // open file
            java.io.File f=new java.io.File(sFile);
            f.delete();
            java.io.FileOutputStream of=new java.io.FileOutputStream(f);

            // encode buffered image to a gif
            GifEncoder encoder = new GifEncoder(image,of);
            encoder.encode();
            of.close();

            }
            catch (Exception e) {
            return false;}

            return true;
        }


        private boolean saveToJPEG() {

          String v=java.lang.System.getProperty("java.version");
          //if ((v.indexOf("1.2")==-1) && (v.indexOf("1.3")==-1)) return false;
          if (v.indexOf("1.1")==0) return false;

           try {

            // create bufferred image
            int bcw=bc.getPreferredSize().width;
            int bch=bc.getPreferredSize().height;
            java.awt.image.BufferedImage image = new java.awt.image.BufferedImage( bcw,bch,java.awt.image.BufferedImage.TYPE_INT_RGB );
            java.awt.Graphics imgGraphics = image.createGraphics();

             bc.paint(imgGraphics );

            // open file
            java.io.File f=new java.io.File(sFile);
            f.delete();
            java.io.FileOutputStream of=new java.io.FileOutputStream(f);

            // encode buffered image to a jpeg
            com.sun.image.codec.jpeg.JPEGImageEncoder encoder = com.sun.image.codec.jpeg.JPEGCodec.createJPEGEncoder(of );

			//increase the JPEG quality to 100%
            com.sun.image.codec.jpeg.JPEGEncodeParam param = encoder.getDefaultJPEGEncodeParam( image ); 
            param.setQuality(1.0F,true);
            encoder.setJPEGEncodeParam(param);
            encoder.encode( image,param );

            of.close();

            }
            catch (Exception e) {return false;}

            return true;

        }



}